<template>
  <div class="mb-8 flex flex-wrap gap-4">
    <ui-button @click="run()">Run async fn</ui-button>
    <ui-button @click="run({ error: true })">Run async fn with error</ui-button>
  </div>
  <ui-loading label="Loading, please wait!" :steps="steps" />
</template>

<script lang="ts" setup>
import { useLoading } from '@/composables'
import { LoadingStepStatus } from '@/enums'

const { steps, $loading } = useLoading()

const fn = ({ error = false } = {}) =>
  new Promise<void>((resolve, reject) =>
    setTimeout(() => {
      if (error) {
        return reject(new Error())
      }

      $loading.addStep(
        {
          id: 'fn-done',
          label: 'Fn done',
          status: LoadingStepStatus.Done,
        },
        { insertBeforeId: 'async-fn' }, // insert before 'async-fn' step
      )
      resolve()
    }, 500),
  )

const run = async ({ error = false } = {}) => {
  $loading.clearSteps()

  await $loading.asyncFn({
    step: {
      label: 'Async fn with min duration of 2s',
      id: 'async-fn',
    },
    fn: fn({ error }),

    minDuration: 2000,
  })
}
</script>
